﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.Serialization.Formatters.Binary;
using System.Text;

#if SERVER
namespace Warensoft.DataService.Models
#else
namespace Warensoft.Unity.Communication.Client.Models
#endif

{
    [Serializable]
    public class ResultInfo
    {
        public static ResultInfo Create(byte[] buffer)
        {

            MemoryStream ms = new MemoryStream(buffer);
            BinaryReader br = new BinaryReader(ms);
            ResultInfo result = new ResultInfo();
            result.OperationDone = br.ReadBoolean();
            result.Message = br.ReadString();
            int objLength = br.ReadInt32();
            if (objLength != 0)
            {
                byte[] objBuffer = new byte[objLength];
                br.Read(objBuffer, 0, objLength);
                BinaryFormatter bf = new BinaryFormatter();
                MemoryStream ms1 = new MemoryStream(objBuffer);
                result.AdditionalData = bf.Deserialize(ms1);
                ms1.Close();
            }

            ms.Close();
            br.Close();
            buffer = null;
            return result;
        }

        public bool OperationDone { get; set; }
        public string Message { get; set; }
        public object AdditionalData { get; set; }
        public ResultInfo()
        {
            this.Message = "";
        }
        public byte[] ToArray()
        {

            MemoryStream ms = new MemoryStream();
            BinaryWriter bw = new BinaryWriter(ms);
            bw.Write(this.OperationDone);
            bw.Write(this.Message);
            if (this.AdditionalData == null)
            {
                bw.Write((int)0);
            }
            else
            {
                MemoryStream ms1 = new MemoryStream();
                BinaryFormatter bf = new BinaryFormatter();
                bf.Serialize(ms1, this.AdditionalData);
                var objBuffer = ms1.ToArray();
                ms1.Close();
                bw.Write(objBuffer.Length);
                bw.Write(objBuffer);
            }

            var buffer = ms.ToArray();
            ms.Close();
            bw.Close();
            return buffer;
        }
    }
}
